#
library(MCS); 
library(rugarch);
library(forecast);
library(zoo); 
library(vars)
#
options(max.print = 100000)
# ex.post = c("retsq") ## c("retsq", "range.based") ## 
#
commodity = c("0_cad"); 
nwins <- 1000 # number of windows 1000
smpl_type <- c("quar")
#
data <- read.table(paste(commodity, ".txt", sep=""), header=T)
rets1 <- as.ts(100*diff(log(data[,2]))) # Compute the log return
rets <- rets1[floor(0.5*(length(rets1)-nwins)):length(rets1)] 
plot(rets, col="blue", type="l") # Plot the returns
dev.off()
#
all_smpl <- length(rets)
fixed.smpl <- all_smpl - nwins
R <- all_smpl - fixed.smpl
step <- 1L
##
actual1=tail((rets[1:(fixed.smpl+floor(R/step)*step)])^2, floor(R/step)*step)
#
source("01rol_GARCH-0.5.R")
##
