#
library(MCS); 
library(rugarch);
library(forecast);
library(zoo); 
#
options(max.print = 100000)
#
rol_breaks <- read.table("0_rol_breaks_cad.txt", header=T);
#
last.br.obs <- 200
nwins <- 1000
step <- 1L
#
commodity = c("0_cad"); 
#
data <- read.table(paste(commodity, ".txt", sep=""), header=T)
rets = as.ts(100*diff(log(data[,2]))) # Compute the log return
plot(rets, col="blue", type="l") # Plot the returns
dev.off()
#
all_smpl <- length(rets)
fixed.smpl <- all_smpl - nwins
R <- all_smpl - fixed.smpl
##
actual1=tail((rets[1:(fixed.smpl+floor(R/step)*step)])^2, floor(R/step)*step)
#  
#### Rolling window ####
#
## Opt mean GARCH models for the last break period 
#  
source("01rol_GARCH-break.R") #done

