#
library(MCS); 
library(rugarch);
library(forecast);
library(zoo); 
library(vars)
#
options(max.print = 100000)
#
commodity = c("0_cad"); 
nwins <- 1000
smpl_type <- c("full") ## "half", "quar" or any other name in string form
#
## "full" uses all available sample
## "half" uses 50% of the sample
## "quar" uses 25% of the sample
#
data <- read.table(paste(commodity, ".txt", sep=""), header=T)
rets <- as.ts(100*diff(log(data[,2]))) # Compute the log return
plot(rets, col="blue", type="l") # Plot the returns
dev.off()
#
all_smpl <- length(rets)
fixed.smpl <- all_smpl - nwins
R <- all_smpl - fixed.smpl
step <- 1L
##
actual1=tail((rets[1:(fixed.smpl+floor(R/step)*step)])^2, floor(R/step)*step)
#
#### Recursive window ####
#
source("01exp_sGARCH-norm.R")
