##################################
######## MCS test ########
#
  {
# library(MCS); 
library(rugarch);
#
## Create the loss matrix by "AE1". 
#
exch_rate = c("0_cad");
step = 1L
#
## Create the loss matrix by "AE1". 
#
options(max.print = 1000000)
length(list.files(pattern = "AE1"))
file.list2 <- intersect(list.files(pattern = "txt"), list.files(pattern = "AE1"))
#
length( file.list2 )
file.list3 <- intersect(file.list2, list.files(pattern = paste("-", exch_rate, sep=""))) 
#
file.list3 <- intersect(file.list3, list.files(pattern = "retsq"))
file.list3 <- intersect(file.list3, list.files(pattern = "rol"))
#
length( file.list3 )
#
all_models_losses <- lapply( file.list3 , read.table)
all_models_losses = do.call(cbind, all_models_losses )
#
dim(all_models_losses)
#
is.na(all_models_losses) <- sapply(all_models_losses, is.infinite) 
## This line changes "inf" with "NA"
#
all_models_losses <- all_models_losses[ , colSums(is.na(all_models_losses)) < 1]
all_models_losses <- na.omit(all_models_losses)
## Above two lines removes the columns with NAs
#
dim(all_models_losses) # Shows the dimension of the data frame
#
write.table(all_models_losses, file = paste("01_Loss.Vol_AE1", "s",
            paste(step, ".txt", sep=""), sep = "-"), append = FALSE )
#
## Load the losses to conduct MCS
#
losses <- read.table(paste("01_Loss.Vol_AE1", "s",
            paste(step, ".txt", sep=""), sep = "-"), header=T)
#
nrow(losses); ncol(losses)
#
##### MCS in rugarch package #####
#
MCS <- mcsTest(losses=losses[1:nrow(losses), 1:ncol(losses)], alpha=0.10, nboot = 10000, 
               nblock = 4, boot = "stationary")
 }
# print(MCS)
#
## Range based test
#
 {
  incl_R_AE1_1L <- MCS$includedR
  excl_R_AE1_1L <- MCS$excludedR
  #
  all_incl_excl_R_AE1_1L <- union(excl_R_AE1_1L, incl_R_AE1_1L)
  R_test_AE1_1L <- cbind(all_incl_excl_R_AE1_1L, MCS$pvalsR)
  names_excl_R_AE1_1L <- names(losses[MCS$excludedR])
  names_incl_R_AE1_1L <- names(losses[MCS$includedR])
  union(names_excl_R_AE1_1L, names_incl_R_AE1_1L)
  #
  table_R_AE1_1L <- cbind( union(names_excl_R_AE1_1L, names_incl_R_AE1_1L), R_test_AE1_1L, 
          (length(all_incl_excl_R_AE1_1L)):1 )
  table_R_AE1_1L <- table_R_AE1_1L[order(as.numeric(table_R_AE1_1L[,4])), ]
  final_R_AE1_1L <- head(table_R_AE1_1L, length(incl_R_AE1_1L)) 
  colnames(final_R_AE1_1L) = c("Model", "order", "pvals","rank")
  print(final_R_AE1_1L)
}
#
{
  incl_SQ_AE1_1L <- MCS$includedSQ
  excl_SQ_AE1_1L <- MCS$excludedSQ
  
  all_incl_excl_SQ_AE1_1L <- union(excl_SQ_AE1_1L, incl_SQ_AE1_1L)
  SQ_test_AE1_1L <- cbind(all_incl_excl_SQ_AE1_1L, MCS$pvalsSQ)
  names_excl_SQ_AE1_1L <- names(losses[MCS$excludedSQ])
  names_incl_SQ_AE1_1L <- names(losses[MCS$includedSQ])
  union(names_excl_SQ_AE1_1L, names_incl_SQ_AE1_1L)
  
  table_SQ_AE1_1L <- cbind( union(names_excl_SQ_AE1_1L, names_incl_SQ_AE1_1L), SQ_test_AE1_1L, 
                            (length(all_incl_excl_SQ_AE1_1L)):1 )
  table_SQ_AE1_1L <- table_SQ_AE1_1L[order(as.numeric(table_SQ_AE1_1L[,4])), ]
  final_SQ_AE1_1L <- head(table_SQ_AE1_1L, length(incl_SQ_AE1_1L)) 
  colnames(final_SQ_AE1_1L) = c("Model", "order", "pvals","rank")
  print(final_SQ_AE1_1L)
}