##
model = c("riskM")
model.name = c(paste(model, paste(R), "full", sep="-"))
##
## Making loop
##
options(max.print = 100000)
ets.fit <- list() 
forc <- list()
out.forc <- list()
vol.forc <- list()
##
for (i in seq(step,R,step)) {
  ets.fit[[i]] <- ets(tail((rets[(1):(fixed.smpl+i-step)])^2, fixed.smpl), model = "ZZZ")
  forc[[i]] = forecast(ets.fit[[i]], h=step)
  print(forc[[i]])
  # vol.forc[[i]] <- forc[[i]]
  #
  for (k in seq(1, step, 1)) {
    out.forc[[k]] <- forc[[i]][[2]][[k]]
    cat(out.forc[[k]],file=paste(model.name, step, paste(commodity, ".txt", sep=""), sep="-"), sep="\n", append=TRUE)
  print(out.forc[[k]])
    }
  # 
  print(i)
  print(model.name)
}

######################### Prepare the data for LossVol ###########3
options(max.print = 100000)
forecasts = read.table(paste(model.name, step, paste(commodity, ".txt", sep=""), sep="-"), header=F) # Load the data
######################### Prepare the data for LossVol ###########3

Loss.Vol_AE1 <- LossVol(which = "AE1", realized=actual1, evaluated = forecasts)

Loss.Vol_AE2 <- LossVol(which = "AE2", realized=actual1, evaluated = forecasts)

Loss.Vol_QLIKE <- LossVol(which = "QLIKE", realized=sqrt(actual1), evaluated = sqrt(abs(forecasts)) )

Loss.Vol_SE1 <- LossVol(which = "SE1", realized=actual1, evaluated = forecasts)

Loss.Vol_SE2 <- LossVol(which = "SE2", realized=actual1, evaluated = forecasts)

Loss.Vol_R2LOG <- LossVol(which = "R2LOG", realized=sqrt(actual1), evaluated = sqrt(abs(forecasts)) )

Loss.Vol_HMSE <- (LossVol(which = "SE1", realized=actual1, evaluated = forecasts)) / forecasts^2

Loss.Vol_HMAE <- (LossVol(which = "AE1", realized=actual1, evaluated = forecasts)) / forecasts

#### Saving the results in the working dyrectory ######

options(max.print = 100000)

colnames(Loss.Vol_AE1) <- model.name
colnames(Loss.Vol_AE2) <- model.name
colnames(Loss.Vol_SE1) <- model.name
colnames(Loss.Vol_SE2) <- model.name
colnames(Loss.Vol_QLIKE) <- model.name
colnames(Loss.Vol_R2LOG) <- model.name
colnames(Loss.Vol_HMSE) <- model.name
colnames(Loss.Vol_HMAE) <- model.name

out.lossvol_AE1 <- capture.output(Loss.Vol_AE1)
cat(out.lossvol_AE1, file=paste(model.name,"Loss.Vol_AE1", step, "retsq", paste(commodity, ".txt", sep=""), sep = "-"),sep="\n",append=TRUE)

out.lossvol_AE2 <- capture.output(Loss.Vol_AE2)
cat(out.lossvol_AE2, file=paste(model.name,"Loss.Vol_AE2", step, "retsq", paste(commodity, ".txt", sep=""), sep = "-"),sep="\n",append=TRUE)

out.lossvol_SE1 <- capture.output(Loss.Vol_SE1)
cat(out.lossvol_SE1, file=paste(model.name,"Loss.Vol_SE1", step, "retsq", paste(commodity, ".txt", sep=""), sep = "-"),sep="\n",append=TRUE)

out.lossvol_SE2 <- capture.output(Loss.Vol_SE2)
cat(out.lossvol_SE2, file=paste(model.name,"Loss.Vol_SE2", step, "retsq", paste(commodity, ".txt", sep=""), sep = "-"),sep="\n",append=TRUE)

out.lossvol_QLIKE <- capture.output(Loss.Vol_QLIKE)
cat(out.lossvol_QLIKE, file=paste(model.name,"Loss.Vol_QLIKE", step, "retsq", paste(commodity, ".txt", sep=""), sep = "-"),sep="\n",append=TRUE)

out.lossvol_R2LOG <- capture.output(Loss.Vol_R2LOG)
cat(out.lossvol_R2LOG, file=paste(model.name,"Loss.Vol_R2LOG", step, "retsq", paste(commodity, ".txt", sep=""), sep = "-"),sep="\n",append=TRUE)

out.lossvol_HMSE <- capture.output(Loss.Vol_HMSE)
cat(out.lossvol_HMSE, file=paste(model.name,"Loss.Vol_HMSE", step, "retsq", paste(commodity, ".txt", sep=""), sep = "-"),sep="\n",append=TRUE)

out.lossvol_HMAE <- capture.output(Loss.Vol_HMAE)
cat(out.lossvol_HMAE, file=paste(model.name,"Loss.Vol_HMAE", step, "retsq", paste(commodity, ".txt", sep=""), sep = "-"),sep="\n",append=TRUE)

#### END #####